/**
 * Un oggetto della classe <code>ErreTre</code> rappresenta
 * un elemento dello spazio vettoriale R^3
 * @author Alessandra Di Pierro
 * @version 3.0
 */
package jad.vettori;

import prog.io.*;
public class ErreTre  {
    // CAMPI
    protected double x; // prima coordinata
    protected double y; // seconda coordinata
    protected double z; // terza coordinata

    private int dummy;

  // COSTRUTTORI
  /**
   * Costruisce un nuovo vettore in R^3
   *@param x prima coordinata
   *@param y seconda coordinata
   *@param z terza coordinata
   */
  public ErreTre(double x, double y, double z) {
    this.x = x;
    this.y = y;
    this.z = z;
  }


  // METODI
    /**
     * Costruisce un vettore in R^3
     * e lo stampa
     */
    public void ppp(){
	ConsoleInputManager in = new ConsoleInputManager();
	ConsoleOutputManager out = new ConsoleOutputManager();
	ErreTre x = new ErreTre(0.0,0.0,0.0);
	x.dummy = 4;
	out.println("x   "+x);
    }

    /**
     * Modifica le coordinate del vettore su cui viene invocato
     * sommando a d esse quelle del vettore parametro
     */	
    public void piu(ErreTre v) {
	this.x = this.x + v.x;
	this.y = this.y + v.y;
	this.z = this.z + v.z;
    }

    /**
     * Modifica le coordinate del vettore su cui viene invocato
     * moltiplicandole per uno scalare
     */	
    public void moltS(double s) {
	this.x = s * this.x;
	this.y = s * this.y;
	this.z = s * this.z;
    }


    public boolean equals(ErreTre v) {
	return this.x == v.x && this.y == v.y && this.z == v.z;
    }


    public boolean equals(Object o) {
	if (o instanceof ErreTre) {
	    ErreTre a = (ErreTre) o;
	    return equals(a);
	} else
	    return false;
    }
    

  public String toString() {
      return "<"+ this.x +" , "+ this.y +" , "+ this.z +" > "+
	  "dummy " + this.dummy;
  }

    public double getX() {
	return this.x;
    }

    public double getY() {
	return this.y;
    }

    public double getZ() {
	return this.z;
    }


    public void setX(double x) {
	this.x = x;
    }

    public void setY(double y) {
	this.y = y;
    }
    public void setZ(double z) {
	this.z = z;
    }

    /**
     *Trasforma il vettore su cui viene invocato
     * nel vettore origine (zero)
     */	
    public  void azzera(){
	this.x = 0;
	this.y = 0;
	this.z = 0;
    }

}
